"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditionMarkerAccount = void 0;
const buffer_1 = require("buffer");
const bn_js_1 = __importDefault(require("bn.js"));
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const tokenMetadata_1 = require("./..");
const shared_1 = require("../../../shared");
class EditionMarkerAccount extends shared_1.BaseAccount {
    static pda(mint, edition) {
        return __awaiter(this, void 0, void 0, function* () {
            return shared_1.Pda.find(tokenMetadata_1.TokenMetadataProgram.publicKey, [
                buffer_1.Buffer.from('metadata', 'utf8'),
                tokenMetadata_1.TokenMetadataProgram.publicKey.toBuffer(),
                mint.toBuffer(),
                buffer_1.Buffer.from('edition', 'utf8'),
                buffer_1.Buffer.from(edition.div(new bn_js_1.default(248)).toString()),
            ]);
        });
    }
    static from(unparsedAccount) {
        return new EditionMarkerAccount(this.parse(unparsedAccount, mpl_token_metadata_1.EditionMarker));
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
}
exports.EditionMarkerAccount = EditionMarkerAccount;
//# sourceMappingURL=EditionMarkerAccount.js.map