"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OriginalOrPrintEditionAccount = void 0;
const tokenMetadata_1 = require("./..");
const shared_1 = require("../../../shared");
const errors_1 = require("../../../errors");
class OriginalOrPrintEditionAccount extends shared_1.BaseAccount {
    static pda(mint) {
        return __awaiter(this, void 0, void 0, function* () {
            return tokenMetadata_1.OriginalEditionAccount.pda(mint);
        });
    }
    static recognizes(buffer) {
        return tokenMetadata_1.OriginalEditionAccount.recognizes(buffer) || tokenMetadata_1.PrintEditionAccount.recognizes(buffer);
    }
    static from(unparsedAccount) {
        if (!this.recognizes(unparsedAccount.data)) {
            throw new errors_1.UnexpectedAccountError(unparsedAccount.publicKey, 'MasterEditionV1|MasterEditionV2|EditionV1');
        }
        const account = tokenMetadata_1.OriginalEditionAccount.recognizes(unparsedAccount.data)
            ? tokenMetadata_1.OriginalEditionAccount.from(unparsedAccount)
            : tokenMetadata_1.PrintEditionAccount.from(unparsedAccount);
        return new OriginalOrPrintEditionAccount(account);
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
    isOriginal() {
        return 'maxSupply' in this.data;
    }
    isPrint() {
        return !this.isOriginal();
    }
}
exports.OriginalOrPrintEditionAccount = OriginalOrPrintEditionAccount;
//# sourceMappingURL=OriginalOrPrintEditionAccount.js.map