"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrintEditionAccount = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const OriginalEditionAccount_1 = require("./OriginalEditionAccount");
const shared_1 = require("../../../shared");
class PrintEditionAccount extends shared_1.BaseAccount {
    static pda(mint) {
        return __awaiter(this, void 0, void 0, function* () {
            return OriginalEditionAccount_1.OriginalEditionAccount.pda(mint);
        });
    }
    static recognizes(buffer) {
        return (buffer === null || buffer === void 0 ? void 0 : buffer[0]) === mpl_token_metadata_1.Key.EditionV1;
    }
    static from(unparsedAccount) {
        return new PrintEditionAccount(this.parse(unparsedAccount, mpl_token_metadata_1.Edition));
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
}
exports.PrintEditionAccount = PrintEditionAccount;
//# sourceMappingURL=PrintEditionAccount.js.map