"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseAccount = void 0;
const errors_1 = require("../errors");
class BaseAccount {
    constructor(accountValue) {
        this.exists = true;
        this.publicKey = accountValue.publicKey;
        this.executable = accountValue.executable;
        this.owner = accountValue.owner;
        this.lamports = accountValue.lamports;
        this.data = accountValue.data;
        this.rentEpoch = accountValue.rentEpoch;
    }
    static parse(unparsedAccount, accountData) {
        try {
            const data = accountData.fromAccountInfo(unparsedAccount)[0];
            return Object.assign(Object.assign({}, unparsedAccount), { data });
        }
        catch (error) {
            throw new errors_1.UnexpectedAccountError(unparsedAccount.publicKey, accountData.name, error);
        }
    }
    static parseMaybe(unparsedMaybeAccount, accountData) {
        if (!unparsedMaybeAccount.exists) {
            return unparsedMaybeAccount;
        }
        const parsedAccount = this.parse(unparsedMaybeAccount, accountData);
        return Object.assign(Object.assign({}, parsedAccount), { exists: true });
    }
}
exports.BaseAccount = BaseAccount;
//# sourceMappingURL=BaseAccount.js.map