import { Model } from "../../../shared";
import { removeEmptyChars } from "../../../utils";
import { useJsonMetadataTask } from './useJsonMetadataTask';
import { useEditionTask } from './useEditionTask';
export class Nft extends Model {
    constructor(metadataAccount, metaplex) {
        super();
        this.metadataAccount = metadataAccount;
        this.metadataTask = useJsonMetadataTask(metaplex, this);
        this.editionTask = useEditionTask(metaplex, this);
        this.updateAuthority = metadataAccount.data.updateAuthority;
        this.mint = metadataAccount.data.mint;
        this.name = removeEmptyChars(metadataAccount.data.data.name);
        this.symbol = removeEmptyChars(metadataAccount.data.data.symbol);
        this.uri = removeEmptyChars(metadataAccount.data.data.uri);
        this.sellerFeeBasisPoints = metadataAccount.data.data.sellerFeeBasisPoints;
        this.creators = metadataAccount.data.data.creators;
        this.primarySaleHappened = metadataAccount.data.primarySaleHappened;
        this.isMutable = metadataAccount.data.isMutable;
        this.editionNonce = metadataAccount.data.editionNonce;
        this.tokenStandard = metadataAccount.data.tokenStandard;
        this.collection = metadataAccount.data.collection;
        this.uses = metadataAccount.data.uses;
    }
    get metadata() {
        var _a;
        return (_a = this.metadataTask.getResult()) !== null && _a !== void 0 ? _a : {};
    }
    get editionAccount() {
        var _a;
        return (_a = this.editionTask.getResult()) !== null && _a !== void 0 ? _a : null;
    }
    get originalEdition() {
        var _a;
        if (!((_a = this.editionAccount) === null || _a === void 0 ? void 0 : _a.isOriginal())) {
            return null;
        }
        return this.editionAccount.data;
    }
    get printEdition() {
        var _a;
        if (!((_a = this.editionAccount) === null || _a === void 0 ? void 0 : _a.isPrint())) {
            return null;
        }
        return this.editionAccount.data;
    }
    is(other) {
        const mint = other instanceof Nft ? other.mint : other;
        return this.mint.equals(mint);
    }
    isOriginal() {
        var _a, _b;
        return (_b = (_a = this.editionAccount) === null || _a === void 0 ? void 0 : _a.isOriginal()) !== null && _b !== void 0 ? _b : false;
    }
    isPrint() {
        var _a, _b;
        return (_b = (_a = this.editionAccount) === null || _a === void 0 ? void 0 : _a.isPrint()) !== null && _b !== void 0 ? _b : false;
    }
}
//# sourceMappingURL=Nft.js.map