import { MetadataAccount } from "../../../programs";
import { updateNftBuilder } from '../transactionBuilders';
export const updateNftOperationHandler = {
    handle: async (operation, metaplex) => {
        const { nft, newUpdateAuthority = nft.updateAuthority, primarySaleHappened = nft.primarySaleHappened, isMutable = nft.isMutable, updateAuthority = metaplex.identity(), confirmOptions, } = operation.input;
        const data = resolveData(operation.input);
        const metadata = await MetadataAccount.pda(nft.mint);
        const { signature } = await metaplex.rpc().sendAndConfirmTransaction(updateNftBuilder({
            data,
            newUpdateAuthority,
            primarySaleHappened,
            isMutable,
            updateAuthority,
            metadata,
        }), undefined, confirmOptions);
        return { transactionId: signature };
    },
};
const resolveData = (input) => {
    var _a, _b, _c, _d, _e, _f, _g;
    const { nft } = input;
    return {
        name: (_a = input.name) !== null && _a !== void 0 ? _a : nft.name,
        symbol: (_b = input.symbol) !== null && _b !== void 0 ? _b : nft.symbol,
        uri: (_c = input.uri) !== null && _c !== void 0 ? _c : nft.uri,
        sellerFeeBasisPoints: (_d = input.sellerFeeBasisPoints) !== null && _d !== void 0 ? _d : nft.sellerFeeBasisPoints,
        creators: (_e = input.creators) !== null && _e !== void 0 ? _e : nft.creators,
        collection: (_f = input.collection) !== null && _f !== void 0 ? _f : nft.collection,
        uses: (_g = input.uses) !== null && _g !== void 0 ? _g : nft.uses,
    };
};
//# sourceMappingURL=updateNftOperationHandler.js.map