import { Buffer } from 'buffer';
import BN from 'bn.js';
import { EditionMarker } from '@metaplex-foundation/mpl-token-metadata';
import { TokenMetadataProgram } from "./..";
import { BaseAccount, Pda } from "../../../shared";
export class EditionMarkerAccount extends BaseAccount {
    static async pda(mint, edition) {
        return Pda.find(TokenMetadataProgram.publicKey, [
            Buffer.from('metadata', 'utf8'),
            TokenMetadataProgram.publicKey.toBuffer(),
            mint.toBuffer(),
            Buffer.from('edition', 'utf8'),
            Buffer.from(edition.div(new BN(248)).toString()),
        ]);
    }
    static from(unparsedAccount) {
        return new EditionMarkerAccount(this.parse(unparsedAccount, EditionMarker));
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
}
//# sourceMappingURL=EditionMarkerAccount.js.map