import { Buffer } from 'buffer';
import { Metadata } from '@metaplex-foundation/mpl-token-metadata';
import { TokenMetadataProgram } from "./..";
import { BaseAccount, Pda } from "../../../shared";
export class MetadataAccount extends BaseAccount {
    static async pda(mint) {
        return Pda.find(TokenMetadataProgram.publicKey, [
            Buffer.from('metadata', 'utf8'),
            TokenMetadataProgram.publicKey.toBuffer(),
            mint.toBuffer(),
        ]);
    }
    static from(unparsedAccount) {
        return new MetadataAccount(this.parse(unparsedAccount, Metadata));
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
}
//# sourceMappingURL=MetadataAccount.js.map