import { Edition, Key } from '@metaplex-foundation/mpl-token-metadata';
import { OriginalEditionAccount } from './OriginalEditionAccount';
import { BaseAccount } from "../../../shared";
export class PrintEditionAccount extends BaseAccount {
    static async pda(mint) {
        return OriginalEditionAccount.pda(mint);
    }
    static recognizes(buffer) {
        return (buffer === null || buffer === void 0 ? void 0 : buffer[0]) === Key.EditionV1;
    }
    static from(unparsedAccount) {
        return new PrintEditionAccount(this.parse(unparsedAccount, Edition));
    }
    static fromMaybe(maybe) {
        return maybe.exists ? this.from(maybe) : maybe;
    }
}
//# sourceMappingURL=PrintEditionAccount.js.map