import { UnexpectedAccountError } from "../errors";
export class BaseAccount {
    constructor(accountValue) {
        this.exists = true;
        this.publicKey = accountValue.publicKey;
        this.executable = accountValue.executable;
        this.owner = accountValue.owner;
        this.lamports = accountValue.lamports;
        this.data = accountValue.data;
        this.rentEpoch = accountValue.rentEpoch;
    }
    static parse(unparsedAccount, accountData) {
        try {
            const data = accountData.fromAccountInfo(unparsedAccount)[0];
            return { ...unparsedAccount, data };
        }
        catch (error) {
            throw new UnexpectedAccountError(unparsedAccount.publicKey, accountData.name, error);
        }
    }
    static parseMaybe(unparsedMaybeAccount, accountData) {
        if (!unparsedMaybeAccount.exists) {
            return unparsedMaybeAccount;
        }
        const parsedAccount = this.parse(unparsedMaybeAccount, accountData);
        return { ...parsedAccount, exists: true };
    }
}
//# sourceMappingURL=BaseAccount.js.map