/// <reference types="node" />
import { AccountInfo, Blockhash, Commitment, ConfirmOptions, PublicKey, SendOptions, Transaction, TransactionSignature } from '@solana/web3.js';
import { Signer, TransactionBuilder, UnparsedMaybeAccount } from "../../shared";
import { RpcDriver, ConfirmTransactionResponse, SendAndConfirmTransactionResponse } from './RpcDriver';
import { Buffer } from 'buffer';
export declare class Web3RpcDriver extends RpcDriver {
    sendTransaction(transaction: Transaction | TransactionBuilder, signers?: Signer[], sendOptions?: SendOptions): Promise<TransactionSignature>;
    confirmTransaction(signature: TransactionSignature, commitment?: Commitment): Promise<ConfirmTransactionResponse>;
    sendAndConfirmTransaction(transaction: Transaction | TransactionBuilder, signers?: Signer[], confirmOptions?: ConfirmOptions): Promise<SendAndConfirmTransactionResponse>;
    getAccount(publicKey: PublicKey, commitment?: Commitment): Promise<UnparsedMaybeAccount>;
    getMultipleAccounts(publicKeys: PublicKey[], commitment?: Commitment): Promise<UnparsedMaybeAccount[]>;
    protected getLatestBlockhash(): Promise<Blockhash>;
    protected getDefaultFeePayer(): PublicKey | undefined;
    protected getUnparsedMaybeAccount(publicKey: PublicKey, accountInfo: AccountInfo<Buffer> | null): UnparsedMaybeAccount;
}
