import { ConfirmOptions, PublicKey } from '@solana/web3.js';
import { Signer, Operation } from "../../../shared";
export declare const printNewEditionOperation: import("../../../shared").OperationConstructor<PrintNewEditionOperation, "PrintNewEditionOperation", PrintNewEditionInput, PrintNewEditionOutput>;
export declare type PrintNewEditionOperation = Operation<'PrintNewEditionOperation', PrintNewEditionInput, PrintNewEditionOutput>;
export declare type PrintNewEditionInput = PrintNewEditionSharedInput & PrintNewEditionViaInput;
export declare type PrintNewEditionSharedInput = {
    originalMint: PublicKey;
    newMint?: Signer;
    newMintAuthority?: Signer;
    newUpdateAuthority?: PublicKey;
    newOwner?: PublicKey;
    newFreezeAuthority?: PublicKey;
    payer?: Signer;
    tokenProgram?: PublicKey;
    associatedTokenProgram?: PublicKey;
    confirmOptions?: ConfirmOptions;
};
export declare type PrintNewEditionViaInput = {
    via?: 'token';
    originalTokenAccountOwner?: Signer;
    originalTokenAccount?: PublicKey;
} | {
    via: 'vault';
    vaultAuthority: Signer;
    safetyDepositStore: PublicKey;
    safetyDepositBox: PublicKey;
    vault: PublicKey;
    tokenVaultProgram?: PublicKey;
};
export declare type PrintNewEditionOutput = {
    mint: Signer;
    metadata: PublicKey;
    edition: PublicKey;
    associatedToken: PublicKey;
    transactionId: string;
};
