import { PublicKey } from '@solana/web3.js';
import { TransactionBuilder, Signer } from "../../../shared";
import BN from 'bn.js';
declare type PrintNewEditionBuilderSharedParams = {
    lamports: number;
    edition: number | BN;
    newMint: Signer;
    newMetadata: PublicKey;
    newEdition: PublicKey;
    newMintAuthority: Signer;
    newUpdateAuthority: PublicKey;
    newOwner: PublicKey;
    newAssociatedToken: PublicKey;
    newFreezeAuthority?: PublicKey;
    payer: Signer;
    originalMetadata: PublicKey;
    originalEdition: PublicKey;
    originalEditionMarkPda: PublicKey;
    tokenProgram?: PublicKey;
    associatedTokenProgram?: PublicKey;
    createAccountInstructionKey?: string;
    initializeMintInstructionKey?: string;
    createAssociatedTokenInstructionKey?: string;
    mintToInstructionKey?: string;
    printNewEditionInstructionKey?: string;
};
export declare type PrintNewEditionBuilderParams = PrintNewEditionBuilderSharedParams & ({
    via: 'token';
    originalTokenAccountOwner: Signer;
    originalTokenAccount: PublicKey;
} | {
    via: 'vault';
    vaultAuthority: Signer;
    safetyDepositStore: PublicKey;
    safetyDepositBox: PublicKey;
    vault: PublicKey;
    tokenVaultProgram?: PublicKey;
});
export declare const printNewEditionBuilder: (params: PrintNewEditionBuilderParams) => TransactionBuilder;
export {};
