/// <reference types="node" />
import { PublicKey } from '@solana/web3.js';
import { Buffer } from 'buffer';
import { MasterEditionV1, MasterEditionV2 } from '@metaplex-foundation/mpl-token-metadata';
import { BaseAccount, Pda, UnparsedAccount, UnparsedMaybeAccount } from "../../../shared";
export declare class OriginalEditionAccount extends BaseAccount<MasterEditionV1 | MasterEditionV2> {
    static pda(mint: PublicKey): Promise<Pda>;
    static recognizes(buffer: Buffer): boolean;
    static recognizesV1(buffer: Buffer): boolean;
    static recognizesV2(buffer: Buffer): boolean;
    static from(unparsedAccount: UnparsedAccount): OriginalEditionAccount;
    static fromMaybe(maybe: UnparsedMaybeAccount): {
        publicKey: PublicKey;
        exists: false;
    } | OriginalEditionAccount;
}
