/// <reference types="node" />
import { PublicKey } from '@solana/web3.js';
import { Buffer } from 'buffer';
import { Edition } from '@metaplex-foundation/mpl-token-metadata';
import { BaseAccount, Pda, UnparsedAccount, UnparsedMaybeAccount } from "../../../shared";
export declare class PrintEditionAccount extends BaseAccount<Edition> {
    static pda(mint: PublicKey): Promise<Pda>;
    static recognizes(buffer: Buffer): boolean;
    static from(unparsedAccount: UnparsedAccount): PrintEditionAccount;
    static fromMaybe(maybe: UnparsedMaybeAccount): {
        publicKey: PublicKey;
        exists: false;
    } | PrintEditionAccount;
}
