import { Connection, PublicKey } from '@solana/web3.js';
import { Postpone } from './Postpone';
import { UnparsedMaybeAccount } from "./";
export interface GmaBuilderOptions {
    chunkSize?: number;
}
export declare class GmaBuilder {
    protected readonly connection: Connection;
    protected readonly publicKeys: PublicKey[];
    protected chunkSize: number;
    constructor(connection: Connection, publicKeys: PublicKey[], options?: GmaBuilderOptions);
    static make(connection: Connection, publicKeys: PublicKey[], options?: GmaBuilderOptions): GmaBuilder;
    chunkBy(n: number): this;
    addPublicKeys(publicKeys: PublicKey[]): this;
    getPublicKeys(): PublicKey[];
    getUniquePublicKeys(): PublicKey[];
    getFirst(n?: number): Promise<UnparsedMaybeAccount[]>;
    getLast(n?: number): Promise<UnparsedMaybeAccount[]>;
    getBetween(start: number, end: number): Promise<UnparsedMaybeAccount[]>;
    getPage(page: number, perPage: number): Promise<UnparsedMaybeAccount[]>;
    get(): Promise<UnparsedMaybeAccount[]>;
    lazy(): Postpone<UnparsedMaybeAccount[]>;
    getAndMap<T>(callback: (account: UnparsedMaybeAccount) => T): Promise<T[]>;
    protected getChunks(publicKeys: PublicKey[]): Promise<UnparsedMaybeAccount[]>;
    protected getChunk(publicKeys: PublicKey[]): Promise<UnparsedMaybeAccount[]>;
    protected boundNumber(n: number): number;
    protected boundIndex(index: number): number;
}
